; Realdun 3 replayer test rom
;--------------------------------------------------------------------
;                                                  XL2S Entertainment

; M A I N  
;--------------------------------------------------------------------

  module main

  code

@readysetgo

  ld a,0c3h         ; init interrupt routine
  ld (38h),a
  ld hl,interrupt
  ld (38h+1),hl
  ei

  call varinit      ; init test variables for cpu use counting etc.

  jp test


 ; i n t e r r u p t
;--------------------------------------------------------------------

interrupt
  di
  push af
  push hl

  in a,(099h)

  ld a,1
  ld (vsync),a

  pop hl
  pop af
  ei
  ret


; T E S T
;--------------------------------------------------------------------

EMPTY = 0         ; since in page 0, both page no. and address 0

MAXSONG = 10

testsongeq        ; set equalizer on for 50 Hz playback on 60 Hz

  byte 0,1,1,1,0,0,0,0,0,0

testsonginfo

  rword songd.volcano_wd
  rword songd.volcano_sd
  rword EMPTY

;  rword songd.doctor_wd
;  rword songd.test_sd   ;doctor_sd
;  rword EMPTY

  rword songd.spacey_wd
  rword songd.spacey_sd
  rword EMPTY

  rword songd.stretch_wd
  rword songd.stretch_sd
  rword EMPTY

  rword songd.squeeze_wd
  rword songd.squeeze_sd
  rword EMPTY

  rword songd.police_wd
  rword songd.police_sd
  rword EMPTY

  rword songd.andorogy_wd
  rword songd.andorogy_sd
  rword songd.andorogy_sample_jump

  rword songd.staff_wd
  rword songd.bird_sd
  rword songd.bird_sample_jump

;  rword songd.andorogy_wd
;  rword songd.test0_sd
;  rword songd.andorogy_sample_jump

  rword songd.awesome_wd
  rword songd.awesome_sd
  rword EMPTY

  rword songd.letsmod_wd
  rword songd.letsmod_sd
  rword EMPTY

  rword songd.staff_wd
  rword songd.staff_sd
  rword EMPTY


;equalizer_on
;  byte 1              ; set equalizer on for 50 Hz playback on 60 Hz
 

test

  ld a,REPLAYPAGE      ; swap in replayer page
  ld (0b000h),a 

  call replay.clear_variables
  call replay.scc_init           ; activate scc+  (and keep page ;)
  call replay.ay_init

  ld hl,replay.restorerompages   ; to be repaced by something dynamic
  ld (hl),0                      ; but works for this test rom 
  inc l
  ld (hl),1
  inc l
  ld (hl),2

  ld hl,testsonginfo             ; song select
  ld a,(song_nmr)
  ld b,a
  add a
  add a
  add a     ; x 8
  add b     ; x 9
  add l
  jr nc,1f
  inc h
1 ld l,a                         ; hl -> song info
  call replay.start_song

  ld a,(song_nmr)
  ld hl,testsongeq
  add a,l
  jr nc,1f
  inc h
1 ld l,a
  ld a,(hl)                      ; may be system / user dependent
  ld (replay.eq_on),a		 ; set equalizer on/off

  halt                           ; only done to sync interrupt and
                                 ; reset idle time counters...
  call replay.play_out           ; and skip the first initiation of
  call replay.play_process       ; song that will mislead counting

  halt

.lus
  xor a
  ld (vsync),a

  call waitabit

  call replay.play_out           ; main loop for playing music
  call replay.play_process

  ld de,0

.idle
  ld a,(vsync) 
  or a  
  jr nz,.int 
  inc de 
  jr .idle 

.swapsongs
  call replay.stop_song
  ld a,(song_nmr)
  inc a
  cp MAXSONG              
  jr c,1f
  xor a
1 push af
  call varinit      ; test variables for cpu use counting etc.
  pop af
  ld (song_nmr),a
  ld b,20
1 halt            ; wait a bit to allow time for space bar release
  djnz 1b
  jr test


.int

  ; t e s t   s p a c e   k e y
  
  in a,(0aah)
  and 240
  or 8
  out (0aah),a
  in a,(0a9h)
  and 1
  jr z,.swapsongs  


  call .idle_four_count

  ld hl,(idle_count) 
  sbc hl,de
  jr c,.lus

  ; p r i n t   i d l e   t i m e

  ld (idle_count),de   ; update peak

  ld hl,6144+366
  ld a,l
  out (99h),a
  ld a,64
  or h
  out (99h),a

  call .print_de
  jr .lus


.print_de
  
  ld a,d
  rra
  rra
  rra
  rra
  and 15
  cp 10
  jr c,1f
  add 7
1 add 48
  out (98h),a
  ld a,d
  and 15
  cp 10
  jr c,1f
  add 7
1 add 48
  out (98h),a

  ld a,e
  rra
  rra
  rra
  rra
  and 15
  cp 10
  jr c,1f
  add 7
1 add 48
  out (98h),a
  ld a,e
  and 15
  cp 10
  jr c,1f
  add 7
1 add 48
  out (98h),a

  ret



.idle_four_count

  ; i d l e   f o u r   c o u n t

  ld hl,(idle_count_sum)
  add hl,de
  ld (idle_count_sum),hl

  ld a,(int_count)
  inc a
  cp 4
  ld (int_count),a
  ret c              ;not 4th count => ret

  xor a
  ld (int_count),a

  push de            ; >>>

  srl h
  rr l
  srl h
  rr l    ; hl / 4

  ex de,hl

  ld hl,(idle_4_count)
  sbc hl,de
  jr c,.skip_update

  ld (idle_4_count),de

  ld a,low (6144+366+64)
  out (99h),a
  ld a,64
  or high (6144+366+64)
  out (99h),a

  call .print_de

.skip_update         ; <<<
  ld hl,0
  ld (idle_count_sum),hl

  pop de

  ret




waitabit
  ld de,351    ;z80      just to start colors in visable area
;  ld de,4015  ; r800
.lus
  dec de   ; 7
  ld a,e   ; 5
  or d     ; 5
  ret z    ; 6
  jr .lus  ; 13 __ 36 x 351 = 12 636 cylces wait






;--------------------------------------------------------------------

varinit
  ld hl,varsdefault
  ld de,vsync
  ld bc,varsdefault_end-varsdefault
  ldir
  ret

varsdefault
;vsync
  byte 0

;idle_count
  word -1

;idle_count_sum
  word 0

;idle_4_count
  word -1

;int_count
  byte 0

;song_nmr
  byte 0           ; 0 - 3

varsdefault_end


  endmodule

;eof


