
;---------------------------------------------------

/*
  mp8 ram mapper
  mp4 ram mapper
  mp0 ram mapper

  ram8 select ram in page 2 (8000-bfff)
  ram4 select ram in page 1 (4000-7fff)
  ram0 select ram in page 0 (0000-3ffff) no BIOS

  rom8 select rom in page 2 (8000-bfff)
  rom4 select rom in page 1 (4000-7fff)

  map8 rom mapper
  map4 rom mapper
*/

;---------------------------------------------------

memrout=0fc00h

  module memory

  code
init

  ld hl,hirout
  ld de,memrout
  ld bc,lenhirout
  ldir

  in a,(0a8h)
  ld b,a
  and 1100b
  ld (rom4.slot),a
  add a,a
  add a,a
  ld (rom8.slot),a
  add a,a
  add a,a
  ld c,a
  ld a,11_1111b
  and b
  or c
  out (0a8h),a

  ld a,(-1)
  cpl
  and 1100b
  ld c,a
  add a,a
  add a,a
  or c
  ld (-1),a
  ld a,b
  out (0a8h),a

  and 1100_0000b
  ld b,a
  rrca
  rrca
  ld (ram8.slot),a
  rrca
  rrca
  ld (ram4.slot),a
  rrca
  rrca
  ld (ram0.slot),a
  ld a,(-1)
  cpl
  and 1100_0000b
  ld c,a
  rrca
  rrca
  or c
  rrca
  rrca
  or c
  rrca
  rrca
  or c
  ld (-1),a

  ld a,b
  rrca
  rrca
  or b
  rrca
  rrca
  or b
  rrca
  rrca
  or b
  ld (allram),a
  ret

  code
hirout
  phase memrout
@mp8
  ld (mappage8000),a
  out (254),a
  ret
@mp4
  ld (mappage4000),a
  out (253),a
  ret
@mp0
  ld (mappage0000),a
  out (252),a
  ret

@ram8
  in a,(0a8h)
  and ~11_0000b
.slot=$+1
  or 0
  out (0a8h),a
  ret
@ram4
  in a,(0a8h)
  and ~1100b
.slot=$+1
  or 0
  out (0a8h),a
  ret
@ram0
  in a,(0a8h)
  and ~11b
.slot=$+1
  or 0
  out (0a8h),a
  ret

@rom8
  in a,(0a8h)
  and ~11_0000b
.slot=$+1
  or 0
  out (0a8h),a
  ret
@rom4
  in a,(0a8h)
  and ~1100b
.slot=$+1
  or 0
  out (0a8h),a
  ret

@map8
  ld (rompage8),a
  ld (9000h),a
  inc a
  ld (0b000h),a
  ret
@map4
  ld (rompage4),a
  ld (5000h),a
  inc a
  ld (7000h),a
  ret

mappage8000
  byte 0
mappage4000
  byte 0
mappage0000
  byte 0
rompage8
  byte 0
rompage4
  byte 0
allram
  byte 0

  dephase
lenhirout=$-hirout

  endmodule

;eof
