; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment

;                        V A R I A B E L E N
;--------------------------------------------------------------------


; S T R U C T U R E S
;-------------------------------------------------------------------

; S C C    v a r i a b e l e n

                     ; (wave data vanaf 4000h tot 7fffh) 
                     ; (song data vanaf 4000h tot bfffh)
  struct sccv,0                    
                     ; T o n e   s t r e a m

.wait             # 1 ; wait count
.repeat           # 1 ; repeat count
.stream_pnt       # 2 ; stream pointer

                     ; F r e q u e n c y
.freq_update      # 1 ; frequency update flag,  if bit 7 set => sample
.freq             # 2 ; frequency value (low, high)

                     ; V o l u m e
.vol_update       # 1 ; volume update flag
.vol              # 1 ; volume value

                     ; R e l a t i v e   u p d a t e   i n f o
.ctrl_byte        # 1 ; set relative control byte
.deltafreq        # 1 ; increment value frequency

                     ; C a l l
.call             # 1 ; in call flag, if in call => jump
.return           # 2 ; stroom return adress

                     ; W a v e   s t r e a m
.wstatus          # 1 ; wave processing status 
                     ; 0-wait, 1-inc, 2-dec
.incs             # 1 ; inc/dec counter
.waits            # 1 ; waits counter

.w_repeat         # 1 ; wave command repeat count
.w_command        # 1 ; command byte
.w_stream_pnt     # 2 ; wave stream pointer

.wave_update      # 1 ; wave update flag,  if bit 7 set => sample
.wave             # 2 ; pointer -> wave data
.wave_reset       # 2 ; reset wave no. for retrig

; N E W

.isrs_play        # 1 ; sample playing on
.isrs_timer       # 1 ; timer mask
.isrs_control     # 1 ; copy of control byte
.isrs_page        # 1 ; sample rom page no.
.isrs_pnt         # 2 ; sample stream pointer
.isrs_period      # 2 ; sample period

  ends


; A Y   t o n e    v a r i a b e l e n

  struct ayv,sccv
                     ; C a l l
.call             # 1 ; in call flag, if in call => jump
.return           # 2 ; stroom return adress

                     ; T o n e   s t r e a m

.wait             # 1 ; wait count
.repeat           # 1 ; repeat count
.stream_pnt       # 2 ; stream pointer

                     ; F r e q u e n c y
.freq_update      # 1 ; frequency update flag
.freq             # 2 ; frequency value (low, high)

                     ; V o l u m e
.vol_update       # 1 ; volume update flag
.vol              # 1 ; volume value

                     ; R e l a t i v e   u p d a t e   i n f o
.ctrl_byte        # 1 ; set relative control byte
.deltafreq        # 1 ; increment value frequency

.tn_update        # 1 ; tn update
.tn               # 1 ; tone noise enable bits

  ends


; A Y   n o i s e   v a r i a b e l e n

  struct aynv,sccv
                     ; N o i s e   s t r e a m

.dummy            # 2 ; dummy to align noise_update with freq_update

.wait             # 1 ; wait count
.stream_pnt       # 2 ; stream pointer
.return           # 2 ; stroom return adress          

.noise_update     # 1 ; noise update flag
.noise            # 1 ; noise period

.signal           # 1 ; 

  ends


; A Y   a m   v a r i a b e l e n

  struct aymv,sccv
                     ; A M   s t r e a m

                     ; C a l l
.call             # 1 ; in call flag, if in call => jump
.return           # 2 ; stroom return adress

.wait             # 1 ; wait count
.repeat           # 1 ; repeat count
.stream_pnt       # 2 ; stream pointer

                     ; F r e q u e n c y
.freq_update      # 1 ; frequency update flag
.freq             # 2 ; frequency value (low, high)

.shape_update     # 1 ; update shape (retrigger) flag
.shape            # 1 ; am envelope shape

                     ; R e l a t i v e   u p d a t e   i n f o
.ctrl_byte        # 1 ; set relative control byte
.deltafreq        # 1 ; increment value frequency

  ends


;--------------------------------------------------------------------

  map SONG_VARS
sccv1 # sccv
ayv1 # ayv

play_on          # 1 
eq_on            # 1
eq_tel           # 1
ready            # 1
process          # 1

ay_reg_7_update  # 1
ay_reg_7         # 1

position_pointer # 2
tick_count       # 2

isr_timer           # 1
isr_samples_active  # 1

restorerompages  # 3
song_data_page   # 1
wave_data_page   # 1

@timers          # 1

wave_data_base   # 2
song_data_base   # 2

  endmap

  map SONG_VARS + 100h
sccv2 # sccv
ayv2 # ayv
  endmap

  map SONG_VARS + 200h
sccv3 # sccv
ayv3 # ayv
  endmap

  map SONG_VARS + 300h
sccv4 # sccv
aynv1 # aynv
  endmap

  map SONG_VARS + 400h
sccv5 # sccv
aymv1 # aymv
  endmap

;--------------------------------------------------------------------

;eof
