; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment


; A Y    a m    s t r e a m
;--------------------------------------------------------------------
; in: h -> high ayv #
; uit:

; call ay_am_stream.run 


ay_am_stream

 ; c a l l   /   j u m p

.call
  ld b,a               ; hoge deel onthouden
  ld a,(de)            ; read low call adress
  inc de
  ld c,a               ; bc - call / jump adress

  ld l,aymv.call      ; in subroutine => jump i.p.v. call
  ld a,(hl)
  or a
  jr nz,.jump

  ld (hl),l            ; call active
  inc l                ; hl -> am_return  (save return adress)
  ld (hl),e
  inc l
  ld (hl),d

.jump
  ld a,64               ; shift adress range naar 4000h - bffffh
  add b
  ld e,c                ; de -> subroutine stroom 
  ld d,a
  jp .in_call_ret

  ; r e t u r n

.return
  ld l,aymv.call
  ld (hl),a            ; reset call status (a = 0 = ret code)
  inc l                ; hl -> am_return
  ld e,(hl)
  inc l
  ld d,(hl)
  jp .in_call_ret

  ; w a i t

.wait_set
  ld l,aymv.wait       ; hl -> wait
  dec a
  jr z,.wait_extented
.wait_ext_in
  dec a                ; aantal -1 (event zelf is al 1 wait)
  ld (hl),a
  jp .save_stream_pointer

.wait_extented
  ld a,(de)            ; read wait count from stream
  inc de
  jr .wait_ext_in

.wait_dec
  dec (hl)
  ret  

  ; r u n    s t r e a m                              < < < < < < < <

.run
  xor a

  ld l,aymv.wait   ; hl -> wait count
  cp (hl)
  jr nz,.wait_dec

  inc l                ; hl -> repeat count
  cp (hl)
  jr nz,.repeat 

  inc l                ; hl -> am stream pointer
  ld e,(hl)
  inc l
  ld d,(hl)            ; de -> am stream
;  cp d
;  ret z                ; no stream check?

.in_call_ret

  ld a,(de)            ; read 1st byte from stream
  inc de

  or a
  jr z,.return
  rra
  jr c,.call
  rrca
  jr nc,.wait_set
 
.set_1or2
  rrca
  jr nc,.set_relatief

  ; s e t   1   -   a b s o l u u t

.set_absoluut
  rrca
  jr nc,.set_shape

  ld l,aymv.freq_update  ; update frequency flag
  ld (hl),l 
  inc l                ; hl -> frequency low
  ex de,hl
  ldi                  ; read frequency from stream
  ldi
  ex de,hl

.set_shape
  rrca
  jr nc,.save_stream_pointer

  ld l,aymv.shape_update
  ld (hl),l
  and 7
  or 8
  inc l
  ld (hl),a            ; set new shape


  ; s a v e   s t r e a m   p o i n t e r

.save_stream_pointer
  ld l,aymv.stream_pnt
  ld (hl),e
  inc l
  ld (hl),d
  ret


  ; s e t   2   -   r e l a t i e f

.rel_single_repeat
  ld (hl),1           ; set repeat 1x
  jr .rel_in_0

.rel_init_x_repeat
  ld a,(de)           ; read repeat count
  inc de
  dec a               ; kijken of dit anders kan!!!      * * * * * * 
  ld (hl),a
  ld l,aymv.ctrl_byte
  ld a,(hl)           ; read previous control byte
  jr .rel_in_1

.repeat
  dec (hl)            ; dec counter
  ld l,aymv.stream_pnt
  ld e,(hl)           ; kijken of dit anders kan!!!      * * * * * *      
  inc l
  ld d,(hl)
  ld l,aymv.ctrl_byte
  ld a,(hl)           ; read previous control byte
  jr .rel_in_1        ; execute command


.set_relatief

  ld l,aymv.repeat
  rrca
  jr c,.rel_single_repeat
  cp 20h                ; init multiple repeat
  jr z,.rel_init_x_repeat

.rel_in_0
  ld l,aymv.ctrl_byte
  ld (hl),a            ; save control byte for repeat

  ; r e l a t i v e   f r e q u e n c y   ( i f q )

.rel_in_1
  rrca
  jr c,.rel_freq_add
  rrca
  ld b,a               ; >>
  jr nc,.rel_shape

.rel_set_value_and_add
  set 0,(hl)           ; adjust freq set value & add to just add

  ld a,(de)            ; read delta from stream
  inc de
  inc l                ; hl -> deltafreq 
  ld (hl),a            ; save deltafreq byte

.rel_freq_add_in
  ld l,aymv.freq_update   ; hl -> update frequency flag
  ld (hl),l
  inc l                ; hl -> freq
  or a
  jp s,.rel_add_sign

  add (hl)
  ld (hl),a            ; update frequency low
  jr nc,.rel_shape
  inc l
  inc (hl)             ; update frequency high
  jr .rel_shape

.rel_add_sign
  add (hl)
  ld (hl),a            ; update frequency low
  jr c,.rel_shape      ; => c  i.p.v.  nc
  inc l
  dec (hl)             ; update frequency high
  jr .rel_shape

.rel_freq_add
  inc l                ; hl -> deltafreq 
  rrca
  ld b,a               ; >>
  ld a,(hl)            ; read deltafreq byte
  jr c,.rel_freq_add_in   ; add normal
  neg
  jr .rel_freq_add_in     ; add negative

  ; s h a p e   ( s h p )

.rel_shape
  ld l,aymv.shape_update
  ld a,b               ; <<
  rrca
  jr nc,.save_stream_pointer  ; no update

  ld (hl),l            ; set shape update flag
  rrca
  jr nc,.save_stream_pointer  ; retrig only

.rel_set_new_shape
  inc l                ; hl -> am_shape
  ld a,(de)            ; read shape from stream
  inc de
  ld (hl),a            ; update shape
  jp .save_stream_pointer



;--------------------------------------------------------------------

;eof
