; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment


; A Y    n o i s e    s t r e a m
;--------------------------------------------------------------------
; in: h -> high ayvn #
; uit:

; call ay_noise_stream.run 


ay_noise_stream

 ; c a l l  

.call
  ld b,a               ; hoge deel onthouden
  ld a,(de)            ; read low call adress
  inc de
  ld c,a               ; bc - call / jump adress

  ld l,aynv.return     ; hl -> aynv.return  (save return adress)
  ld (hl),e
  inc l
  ld (hl),d

  ld a,64               ; shift adress range naar 4000h - bffffh
  add b
  ld e,c                ; de -> subroutine stroom 
  ld d,a
  jp .in_call_ret

  ; r e t u r n

.return
  ld l,aynv.return     ; hl -> aynv.return
  ld e,(hl)
  inc l
  ld d,(hl)
  jp .in_call_ret

  ; w a i t

.wait_set
  ld l,aynv.wait       ; hl -> wait
  dec a
  jr z,.wait_extented
.wait_ext_in
  dec a                ; aantal -1 (event zelf is al 1 wait)
  ld (hl),a
  jp .save_stream_pointer

.wait_extented
  ld a,(de)
  inc de
  jr .wait_ext_in

.wait_dec
  dec (hl)
  ret  

  ; r u n    s t r e a m                              < < < < < < < <

.run
  xor a

  ld l,aynv.wait       ; hl -> wait count
  cp (hl)
  jr nz,.wait_dec

  inc l                ; hl -> stroom pointer
  ld e,(hl)
  inc l
  ld d,(hl)            ; de -> stream
;  cp d
;  ret z                ; no stream check?

.in_call_ret

  ld a,(de)            ; read 1st byte from stream
  inc de

  or a
  jr z,.return
  rra
  jr c,.call
  rra
  jr nc,.wait_set

  or a                 ; clear carry
  rra
  jr c,.set_signal

  ; s e t   0   -   n o i s e   p e r i o d 

.set_noise
  ld l,aynv.noise_update ; update volume flag
  ld (hl),l
  inc l                ; hl -> noise period
  ld (hl),a

  ; s a v e   s t r e a m   p o i n t e r

.save_stream_pointer
  ld l,aynv.stream_pnt
  ld (hl),e
  inc l
  ld (hl),d
  ret

.set_signal
  ld l,aynv.signal
  ld (hl),a
  jr .in_call_ret       ; execute next command


;--------------------------------------------------------------------

;eof
