; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment


; A Y    t o n e    s t r e a m
;--------------------------------------------------------------------
; in: h -> high ayv #
; uit:

; call ay_tone_stream.run 


ay_tone_stream

 ; c a l l   /   j u m p

.call
  ld b,a               ; hoge deel onthouden
  ld a,(de)            ; read low call adress
  inc de
  ld c,a               ; bc - call / jump adress

  ld l,ayv.call        ; in subroutine => jump i.p.v. call
  ld a,(hl)
  or a
  jr nz,.jump

  ld (hl),l            ; call active
  inc l                ; hl -> ayv.return  (save return adress)
  ld (hl),e
  inc l
  ld (hl),d

.jump
  ld a,64               ; shift adress range naar 4000h - bffffh
  add b
  ld e,c                ; de -> subroutine stroom 
  ld d,a
  jp .in_call_ret

  ; r e t u r n

.return
  ld l,ayv.call
  ld (hl),a            ; reset call status (a = 0 = ret code)
  inc l                ; hl -> ayv.return
  ld e,(hl)
  inc l
  ld d,(hl)
  jp .in_call_ret

  ; w a i t

.wait_set
  ld l,ayv.wait       ; hl -> wait
  dec a
  jr z,.wait_extented
.wait_ext_in
  dec a                ; aantal -1 (event zelf is al 1 wait)
  ld (hl),a
  jp .save_stream_pointer

.wait_extented
  ld a,(de)
  inc de
  jr .wait_ext_in

.wait_dec
  dec (hl)
  ret  

  ; r u n    s t r e a m                              < < < < < < < <

.run
  xor a

  ld l,ayv.wait        ; hl -> wait count
  cp (hl)
  jr nz,.wait_dec

  inc l                ; hl -> repeat count
  cp (hl)
  jr nz,.repeat 

  inc l                ; hl -> stroom pointer
  ld e,(hl)
  inc l
  ld d,(hl)            ; de -> stream
;  cp d
;  ret z                ; no stream check?

.in_call_ret

  ld a,(de)            ; read 1st byte from stream
  inc de

  or a
  jr z,.return
  rra
  jr c,.call
  rrca
  jr c,.set_1or2or3
  rra                  ; nc -> in
  jr nc,.wait_set

  ; s e t   0   -   v o l u m e 

.set_volume
  ld l,ayv.vol_update  ; update volume flag
  ld (hl),l
  inc l                ; hl -> volume value
  ld (hl),a
  jp .save_stream_pointer

.set_1or2or3
  rrca
  jr nc,.set_relatief
  rra
  jr c,.set_tnbits

  ; s e t   1   -   a b s o l u u t

.set_absoluut

  ld l,ayv.freq_update  ; update frequency flag
  ld (hl),l 
  inc l                ; hl -> frequency low

  ex de,hl
  ldi                  ; read frequency low from stream
  ex de,hl
  and 15
  ld (hl),a            ; save frequency high

  inc l                ; de -> update volume flag
  ld (hl),l            ; set volume update flag
  ld a,(de)            ; read volume byte from stream
  inc de
  inc l
  ld (hl),a            ; set volume update flag

  ; s a v e   s t r e a m   p o i n t e r

.save_stream_pointer
  ld l,ayv.stream_pnt
  ld (hl),e
  inc l
  ld (hl),d
  ret

  ; s e t   3   -   t n   o n / o f f   b i t s

.set_tnbits
  ld l,ayv.tn_update
  ld (hl),l
  inc l
  ld (hl),a           ; save tn bits

  jp .in_call_ret     ; execute next command directly


  ; s e t   2   -   r e l a t i e f

.rel_single_repeat
  ld (hl),1           ; set repeat 1x
  jr .rel_in_0

.rel_init_x_repeat
  ld a,(de)           ; read repeat count
  inc de
  dec a               ; kijken of dit anders kan!!!      * * * * * * 
  ld (hl),a
  ld l,ayv.ctrl_byte
  ld a,(hl)           ; read previous control byte
  jr .rel_in_1

.repeat
  dec (hl)            ; dec counter
  ld l,ayv.stream_pnt
  ld e,(hl)           ; kijken of dit anders kan!!!      * * * * * *      
  inc l
  ld d,(hl)
  ld l,ayv.ctrl_byte
  ld a,(hl)           ; read previous control byte
  jr .rel_in_1        ; execute command

.set_relatief

  ld l,ayv.repeat
  rrca
  jr c,.rel_single_repeat
  cp 20h                ; init multiple repeat
  jr z,.rel_init_x_repeat

.rel_in_0
  ld l,ayv.ctrl_byte
  ld (hl),a            ; save control byte for repeat

  ; r e l a t i v e   f r e q u e n c y   ( i f q )

.rel_in_1
  rrca
  jr c,.rel_freq_add
  rrca
  ld b,a               ; >>
  jr nc,.rel_volume

.rel_set_value_and_add
  set 0,(hl)           ; adjust freq set value & add to just add

  ld a,(de)
  inc de
  inc l                ; hl -> deltafreq 
  ld (hl),a            ; save deltafreq byte

.rel_freq_add_in
  ld l,ayv.freq_update   ; hl -> update frequency flag
  ld (hl),l
  inc l                ; hl -> freq
  or a
  jp s,.rel_add_sign

  add (hl)
  ld (hl),a            ; update frequency low
  jr nc,.rel_volume
  inc l
  inc (hl)             ; update frequency high
  jr .rel_volume

.rel_add_sign
  add (hl)
  ld (hl),a            ; update frequency low
  jr c,.rel_volume     ; => c  i.p.v.  nc
  inc l
  dec (hl)             ; update frequency high
  jr .rel_volume

.rel_freq_add
  inc l                ; hl -> deltafreq 
  rrca
  ld b,a               ; >>
  ld a,(hl)            ; read deltafreq byte
  jr c,.rel_freq_add_in   ; add normal
  neg
  jr .rel_freq_add_in     ; add negative

  ; r e l a t i v e   v o l u m e   ( i v o )

.rel_volume
  ld l,ayv.vol_update
  ld a,b               ; <<
  rrca
  jr c,.rel_inc_volume
  rrca
  jr nc,.save_stream_pointer

.rel_volume_add
  ld (hl),l            ; update volume flag
  inc l                ; hl -> volume
  ld a,(de)            ; read (signed) byte
  inc de
  add (hl)
  ld (hl),a            ; update volume
  jp .save_stream_pointer

.rel_inc_volume
  ld (hl),l            ; update volume flag
  inc l                ; hl -> volume
  rrca
  ld a,(hl)
  jr nc,.rel_inc_vol
  dec a
  ld (hl),a            ; update volume
  jp .save_stream_pointer
.rel_inc_vol
  inc a
  ld (hl),a            ; update volume
  jp .save_stream_pointer




; A Y   p r e p a r e   T N   b i t s
;--------------------------------------------------------------------
                        ;             7    6    5  4  3  2  1  0
ay_prepare_tn_bits      ; eneable |iob=1|ioa=0|nc|nb|na|tc|tb|ta|

  ld a,(ay_reg_7) 
  ld c,a                ; current reg 7 value in c
  xor a
  ld b,a                ; b = 0 => no update
  ld hl,sccv1 + ayv.tn_update

  ; t e s t   T N    b i t   u p d a t e s  

  cp (hl)
  jr nz,.tn_update_1
.tn_2
  inc h
  cp (hl)
  jr nz,.tn_update_2
.tn_3
  inc h
  cp (hl)
  jr nz,.tn_update_3
.tn_4
  cp b                 ; update required?
  ret z

  ld a,c
  ld (ay_reg_7),a             ; store updated reg 7 value
  ld (ay_reg_7_update),a      ; set update

  ret

  ; u p d a t e   c h a n n e l   T N   b i t s

.tn_update_1
  ld (hl),a            ; clear update flag
  inc l
  ld a,(hl)            ; read tn byte
  dec l
  rra                  ; test tone on
  jr c,1f
  set 0,c              ; note: enable bit logic inverted!!!
  jr 2f
1 res 0,c 
2 rra                  ; test noise on
  jr c,1f
  set 3,c
  jr 2f
1 res 3,c 
2 ld b,c               ; set b = c => update
  xor a
  jr .tn_2

.tn_update_2
  ld (hl),a            ; clear update flag
  inc l
  ld a,(hl)            ; read tn byte
  dec l
  rra                  ; test tone on
  jr c,1f
  set 1,c
  jr 2f
1 res 1,c 
2 rra                  ; test noise on
  jr c,1f
  set 4,c
  jr 2f
1 res 4,c 
2 ld b,c               ; set b = c => update
  xor a
  jr .tn_3

.tn_update_3
  ld (hl),a            ; clear update flag
  inc l
  ld a,(hl)            ; read tn byte
  dec l
  rra                  ; test tone on
  jr c,1f
  set 2,c
  jr 2f
1 res 2,c 
2 rra                  ; test noise on
  jr c,1f
  set 5,c
  jr 2f
1 res 5,c 
2 ld b,c               ; set b = c => update
  xor a
  jr .tn_4

;--------------------------------------------------------------------


;eof
