; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment


; p r o c e s s   s t r e a m   d a t a 
;--------------------------------------------------------------------

process_stream_data

  ; s c c 

  ld h,high sccv1               ; hl -> channel variables

  call scc_tone_stream.run      ; process scc channel 1
  call scc_wave_stream.run
  inc h
  call scc_tone_stream.run      ; process scc channel 2
  call scc_wave_stream.run
  inc h
  call scc_tone_stream.run      ; process scc channel 3
  call scc_wave_stream.run
  inc h
  call scc_tone_stream.run      ; process scc channel 4
  call scc_wave_stream.run
  inc h
  call scc_tone_stream.run      ; process scc channel 5
  call scc_wave_stream.run


  ld c,99h
  ld d,128+7
  ld a,011h      ;achtergrond black!!!
  out (c),a
  out (c),d

  ld a,(isr_samples_active)     ; process scc isr samples if active
  or a
  call nz,process_isr_samples
;  call process_isr_samples

  ld c,99h
  ld d,128+7
  ld a,0aah      ;achtergrond dark yellow!!!
  out (c),a
  out (c),d

  ; a y

  ld h,high ayv1                ; hl -> channel variables

  call ay_tone_stream.run       ; process ay channel 1
  inc h
  call ay_tone_stream.run       ; process ay channel 2
  inc h
  call ay_tone_stream.run       ; process ay channel 3
  inc h
  call ay_noise_stream.run      ; process ay noise freq
  inc h
  call ay_am_stream.run         ; process ay am freq and shape

  call ay_prepare_tn_bits       ; prepare tn bits in reg 7


  ld c,99h
  ld d,128+7
  ld a,033h      ;achtergrond light green!!!
  out (c),a
  out (c),d

  ; c h e c k   f o r   n e x t   p a t t e r n

  ld hl,(tick_count)
  dec hl
  ld a,h                        ; ticks = 0 => next pattern
  or l
  call z,update_stream_pointers ; update pointers for next pattern
  ld (tick_count),hl

  ld a,1
  ld (ready),a                  ; set flag ready for register update

  ld c,99h
  ld d,128+7
  ld a,77h      ;achtergrond cyan!!!
  out (c),a
  out (c),d

  ret



; i n i t   /   u p d a t e   s t r e a m   p o i n t e r s
;--------------------------------------------------------------------

update_stream_pointers

  ld hl,(position_pointer)

.init
  ld e,(hl)             ; read tick count
  inc l
  ld d,(hl)
  inc hl                ; hl -> channel stream pointers

  ld a,d                ; if ticks = 0 => loop address
  or e
  jr nz,.no_loop

  ; l o o p   s o n g

  ld a,(hl)             ; update position pointer to loop address
  inc l
  ld h,(hl)
  ld l,a                ; hl -> loop pattern

  ld e,(hl)             ; read tick count
  inc l
  ld d,(hl)
  inc hl                ; hl -> channel stream pointers

.no_loop  

  push de               ; >>>

  ; u p d a t e   s t r e a m   p o i n t e r s

  ; s c c

  ld de,sccv1 + sccv.stream_pnt
  ldi
  ldi
  ld e,sccv.w_stream_pnt
  ldi
  ldi
  ld de,sccv2 + sccv.stream_pnt
  ldi
  ldi
  ld e,sccv.w_stream_pnt
  ldi
  ldi
  ld de,sccv3 + sccv.stream_pnt
  ldi
  ldi
  ld e,sccv.w_stream_pnt
  ldi
  ldi
  ld de,sccv4 + sccv.stream_pnt
  ldi
  ldi
  ld e,sccv.w_stream_pnt
  ldi
  ldi
  ld de,sccv5 + sccv.stream_pnt
  ldi
  ldi
  ld e,sccv.w_stream_pnt
  ldi
  ldi

  ; a y

  ld de,sccv1 + ayv.stream_pnt
  ldi
  ldi
  ld de,sccv2 + ayv.stream_pnt
  ldi
  ldi
  ld de,sccv3 + ayv.stream_pnt
  ldi
  ldi
  ld de,sccv4 + aynv.stream_pnt
  ldi
  ldi
  ld de,sccv5 + aymv.stream_pnt
  ldi
  ldi

  ; s a v e   p o s i t i o n   p o i n t e r

  ld (position_pointer),hl

  ; c a l l   r e s e t s

  ld hl,sccv1 + sccv.call
  xor a
  ld (hl),a   ; 1
  inc h
  ld (hl),a   ; 2
  inc h
  ld (hl),a   ; 3
  inc h
  ld (hl),a   ; 4
  inc h
  ld (hl),a   ; 5

  ld hl,sccv1 + ayv.call

  ld (hl),a   ; 1
  inc h
  ld (hl),a   ; 2
  inc h
  ld (hl),a   ; 3
  inc h       ; not required for noise
  inc h
  ld (hl),a   ; am

  pop hl

  ret

;--------------------------------------------------------------------

;eof
