; R E P L A Y E R
;-------------------------------------------------------------------
;                                                 XL2S Entertainment

; u p d a t e   s c c   &   a y   r e g i s t e r s
;--------------------------------------------------------------------

update_registers

  ld c,99h
  ld d,128+7
  ld a,0bbh      ;achtergrond geel!!!
  out (c),a
  out (c),d

 call update_ay

  ld c,99h
  ld d,128+7
  ld a,099h      ;achtergrond rood!!!
  out (c),a
  out (c),d

  call update_scc

  ld c,99h
  ld d,128+7
  ld a,0ddh      ;achtergrond paars!!!
  out (c),a
  out (c),d

  call update_scc_waves

  ld c,99h
  ld d,128+7
  ld a,055h      ;achtergrond blauw!!!
  out (c),a
  out (c),d

  ret


; u p d a t e   a y   r e g i s t e r s
;--------------------------------------------------------------------

update_ay

  xor a
  ld c,AYIO + 1            ; ay io port

  ld hl,sccv1 + ayv.freq_update

  ; t o n e   f r e q u e n c y 

  cp (hl)
  jr nz,.update_freq_1
.freq_2
  inc h
  cp (hl)
  jr nz,.update_freq_2
.freq_3
  inc h
  cp (hl)
  jr nz,.update_freq_3

  ; n o i s e

.noise

  inc h                ; hl -> aynv.noise_update
  cp (hl)
  jr z,.tn

  ld (hl),a            ; clear update flag
  inc l
  ld a,6
  out (AYIO),a
;  xor a 
  outd                 ; update noise

  ; T N   e n e a b l e   b i t s

.tn

  ld a,(ay_reg_7_update)
  or a
  jr z,.volume

  ld e,a
  ld a,7
  out (AYIO),a
  xor a
  out (c),e
  ld (ay_reg_7_update),a

  ; v o l u m e

.volume

  ld hl,sccv1 + ayv.vol_update

  cp (hl)
  jr nz,.update_vol_1
.vol_2
  inc h
  cp (hl)
  jr nz,.update_vol_2
.vol_3
  inc h
  cp (hl)
  jr nz,.update_vol_3

  ; a m   f r e q u e n c y

.am
  ld hl,sccv5 + aymv.freq_update
  cp (hl)
  jr z,.shape

  ld (hl),a            ; clear update flag
  inc l
  ld a,11
  out (AYIO),a
  inc a
  outi                 ; update am freq low
  inc e
  out (AYIO),a
  xor a
  outd                 ; update am freq high

.shape
  ld l,aymv.shape_update
  cp (hl)
  ret z
  ld (hl),a            ; clear update flag
  inc l
  ld a,13
  out (AYIO),a
  outi
  ret

  ; u p d a t e   f r e q u e n c y

.update_freq_1
  ld (hl),a            ; clear update flag
  inc l                ; hl -> ayv.freq
;  ld a,0              ; reg 0
  out (AYIO),a
  inc a
  outi                 ; out freq low
  out (AYIO),a
  xor a                ; a back to zero
  outd
  dec l                ; hl -> ayv.freq_update restored
  jp .freq_2

.update_freq_2
  ld (hl),a            ; clear update flag
  inc l                ; hl -> ayv.freq
  ld a,2               ; reg 2
  out (AYIO),a
  inc a
  outi                 ; out freq low
  out (AYIO),a
  xor a                ; a back to zero
  outd
  dec l                ; hl -> ayv.freq_update restored
  jp .freq_3

.update_freq_3
  ld (hl),a            ; clear update flag
  inc l                ; hl -> ayv.freq
  ld a,4               ; reg 4
  out (AYIO),a
  inc a
  outi                 ; out freq low
  out (AYIO),a
  xor a                ; a back to zero
  outd
  dec l                ; hl -> ayv.freq_update restored
  jp .noise

  ; u p d a t e   v o l u m e

.update_vol_1
  ld (hl),a            ; clear update flag
  inc l                ; hl -> volume
  ld a,8
  out (AYIO),a         ; select register
  xor a
  outd                 ; out volume
  jp .vol_2

.update_vol_2
  ld (hl),a            ; clear update flag
  inc l                ; hl -> volume
  ld a,9
  out (AYIO),a         ; select register
  xor a
  outd                 ; out volume
  jp .vol_3

.update_vol_3
  ld (hl),a            ; clear update flag
  inc l                ; hl -> volume
  ld a,10
  out (AYIO),a         ; select register
  xor a
  outd                 ; out volume
  jp .am



; u p d a t e   s c c   r e g i s t e r s
;--------------------------------------------------------------------

update_scc

  ld de,SCC_REGISTERS + 0a0h
  ld hl,sccv1 + sccv.freq_update

  xor a

  ; t e s t   f r e q u e n c y   u p d a t e

.freq_1
  cp (hl)
  jr nz,.update_freq_1
.freq_2
  inc h
  cp (hl)
  jr nz,.update_freq_2
.freq_3
  inc h
  cp (hl)
  jr nz,.update_freq_3
.freq_4
  inc h
  cp (hl)
  jr nz,.update_freq_4
.freq_5
  inc h
  cp (hl)
  jr nz,.update_freq_5
.freq_6

  ; t e s t   &   u p d a t e   v o l u m e

  ld hl,sccv1 + sccv.vol_update
  ld e,0aah              ; de -> scc volume register

.vol_1
  cp (hl)
  jr z,1f                ; skip update
  ld (hl),a              ; clear update flag
  inc l                  ; hl -> volume
  ldd                    ; update scc reg, hl -> sccv.vol_update
  inc e                  ; compensate ldd on de 
1 inc e                  ; adjust de for next channel
.vol_2
  inc h
  cp (hl)
  jr z,1f
  ld (hl),a
  inc l
  ldd
  inc e
1 inc e
.vol_3
  inc h
  cp (hl)
  jr z,1f
  ld (hl),a
  inc l
  ldd
  inc e
1 inc e
.vol_4
  inc h
  cp (hl)
  jr z,1f
  inc l
  ldd
  inc e
1 inc e
.vol_5
  inc h
  cp (hl)
  ret z
  ld (hl),a
  inc l                  ; hl -> volume
  ldd                    ; update scc reg
  ret

  ; u p d a t e  f r e q u e n c y

.update_freq_1
  ld e,0a0h            ; de -> scc freq register
  ld (hl),a            ; clear update flag
  jp ns,.update_freq1_sample
  inc l                ; hl -> sccv.freq
  ldi                  ; update scc registers
  ldd
  dec l                ; restore hl -> sccv.freq_update
  jp .freq_2
.update_freq_2
  ld e,0a2h
  ld (hl),a
  jp ns,.update_freq2_sample
  inc l
  ldi
  ldd
  dec l
  jp .freq_3
.update_freq_3
  ld e,0a4h
  ld (hl),a
  jp ns,.update_freq3_sample
  inc l
  ldi
  ldd
  dec l
  jp .freq_4
.update_freq_4
  ld e,0a6h
  ld (hl),a
  jp ns,.update_freq4_sample
  inc l
  ldi
  ldd
  dec l
  jp .freq_5
.update_freq_5
  ld e,0a8h
  ld (hl),a
  jp ns,.update_freq5_sample
  inc l
  ldi
  ldd
  dec l
  jp .freq_6

.update_freq1_sample
  ld l,sccv.isrs_period
  ldi
  ldi
  ld l,sccv.freq_update
  jp .freq_2
.update_freq2_sample
  ld l,sccv.isrs_period
  ldi
  ldi
  ld l,sccv.freq_update
  jp .freq_3
.update_freq3_sample
  ld l,sccv.isrs_period
  ldi
  ldi
  ld l,sccv.freq_update
  jp .freq_4
.update_freq4_sample
  ld l,sccv.isrs_period
  ldi
  ldi
  ld l,sccv.freq_update
  jp .freq_5
.update_freq5_sample
  ld l,sccv.isrs_period
  ldi
  ldi
  ld l,sccv.freq_update
  jp .freq_6


; u p d a t e   s c c   w a v e s
;--------------------------------------------------------------------

update_scc_waves

  ld d,high SCC_REGISTERS
  ld hl,sccv1 + sccv.wave_update

  xor a

  ; t e s t   w a v e   u p d a t e

  cp (hl)
  call nz,.wave_1
  inc h
  cp (hl)
  call nz,.wave_2
  inc h
  cp (hl)
  call nz,.wave_3
  inc h
  cp (hl)
  call nz,.wave_4
  inc h
  cp (hl)
  jr nz,.wave_5
  
  ret

  ; w a v e   c h a n n e l   s e l e c t   h u b

.wave_1
  ld e,00h             ; de -> scc wave ram
  jp .update
.wave_2
  ld e,20h
  jp .update
.wave_3
  ld e,40h
  jp .update
.wave_4
  ld e,60h
  jp .update
.wave_5
  ld e,80h

  ; u p d a t e   w a v e

.update
  push hl              ; >>>

  ld (hl),a            ; clear update flag

  jp ns,.update_sample_wave

  inc l
  ld c,(hl)            ; read wave address
  inc l
  ld h,(hl)
  ld l,c               ; hl -> wave data

[32] ldi               ; update wave in scc ram

  pop hl               ; <<<
;  xor a               ; a still zero ! 
  ret

.update_sample_wave
  ld l,sccv.isrs_page
  ld a,(hl)
  ld (5000h),a         ; swap in sample pages
  inc a
  ld (7000h),a

  inc l
  ld c,(hl)            ; read wave address
  inc l
  push hl              ; >>> hl -> address high

  ld h,(hl)
  ld l,c               ; hl -> wave data

[32] ldi               ; update wave in scc ram

  ld b,h
  ld c,l

  pop hl               ; <<< hl -> address high
  ld (hl),b            ; save pointer to next bin
  dec l
  ld (hl),c

  ld a,(wave_data_page)
  ld (5000h),a         ; restore wave data pages
  inc a
  ld (7000h),a

  pop hl               ; <<<
  xor a
  ret


;--------------------------------------------------------------------

;eof
